<template lang="pug">
section.section.form-section
  div
    .form-section__plane
      span

    transition(name="fade")
      .form-section__inner(
        v-if="!successMessage"
      )
        .container.form-section__container
          .form-section__plane-img(v-if="bg || bgDouble")
            img(:src="bg || bgDouble" :srcset="bg && bgDouble ? `${bg} 1x, ${bgDouble} 2x` : null" alt="")

          .section-heading.section-heading--mb-sm.section-heading--white
            h2.section-heading__title(v-if="title")
              div(v-html="title")
            .section-heading__subtitle(v-if="subtitle" v-html="subtitle")

          form.form(@submit.prevent="submit" v-if="!successMessage")
            .form-item.icon-user(
              :class="{ 'has-error': $v.form.name.$dirty && $v.form.name.$invalid }"
            )
              span.form-item__error(v-if="$v.form.name.$dirty && !$v.form.name.required") {{ $t('forms.errors.required') }}
              input.form-field(
                type="text"
                name="name"
                v-model="form.name"
                maxlength="255"
                :placeholder="`${$t('forms.fields.fullName')} *`"
              )

            .form-item.icon-phone(
              :class="{ 'has-error': $v.form.phone_number.$dirty && $v.form.phone_number.$invalid }"
            )
              span.form-item__error(v-if="$v.form.phone_number.$dirty && !$v.form.phone_number.required") {{ $t('forms.errors.required') }}
              input.form-field(
                type="tel"
                name="phone_number"
                v-mask="'+###########'"
                v-model="form.phone_number"
                maxlength="18"
                pattern="[0-9]*"
                :placeholder="`${$t('forms.fields.phone')} *`"
              )

            .form-item.icon-email(
              :class="{ 'has-error': $v.form.email.$dirty && $v.form.email.$invalid }"
            )
              span.form-item__error(v-if="$v.form.email.$dirty && !$v.form.email.required") {{ $t('forms.errors.required') }}
              span.form-item__error(v-else-if="$v.form.email.$dirty && !$v.form.email.email") {{ $t('forms.errors.email') }}
              input.form-field(
                type="email"
                name="email"
                v-model="form.email"
                maxlength="254"
                placeholder="E-mail *"
              )

            label.form__accept.checkbox(v-if="settings && settings.agree_text")
              input(type="checkbox" name="accept" v-model="agree")
              div(v-html="settings.agree_text")

            .form__submit
              button.btn(type="button" :disabled="!agree" @click.prevent="submit") {{ $t('forms.buttons.send') }}

          h2.h2.text-white(v-else) {{ successMessage.message }}

      .form-thank.form-thank--dark(v-if="successMessage")
        .form-thank__close(@click="successMessage = null") {{ $t('forms.buttons.close') }}
        div
          .form-thank__svg
          .form-thank__title(v-if="successTitle" v-html="successTitle")
          .form-thank__descr(v-if="successContent" v-html="successContent")
          .share-link(v-if="referralLink")
            .share-link__input-wrap
              .share-link__icon.icon-link
              .share-link__input
                .form-item.form-item--light
                  input.form-field.form-field--sm.readonly(
                    type="text"
                    :value="referralLink"
                    readonly
                    ref="refInput"
                  )

            .share-link__buttons
              button.btn.btn--sm.btn--simple(
                type="button"
                @click="copyStringToClipboard()"
              ) {{ $t('forms.buttons.copy') }}
              button.btn.btn--sm.btn--simple.btn--secondary2(
                v-if="allowShare"
                type="button"
                @click="share"
              ) {{ $t('forms.buttons.share') }}
              .dropdown-wrap(v-else)
                transition(name="fade")
                  ul.dropdown.dropdown--gray(
                    v-show="isShareDropdownShown"
                  )
                    li(v-for="option in shareOptions")
                      .item(@click="shareSocial(option.value)") {{ option.text }}

                .btn.btn--sm.btn--simple.btn--secondary2(
                  @click="isShareDropdownShown = !isShareDropdownShown"
                ) {{ $t('forms.buttons.share') }}

          .form-thank__send-link(v-if="emailTitle" v-html="emailTitle")
          .form-thank__social-title(v-if="settings && settings.form_socials_title" v-html="settings.form_socials_title")
          socials(classes="social--white form-thank__socials")
</template>

<script>
import { formMixin } from '@/mixins/forms'
import { validationMixin } from 'vuelidate'
import { email } from '@/utils/validators'
import { required } from 'vuelidate/lib/validators'
import API from '@/api'
import { getReferralCode } from '@/utils/referrals'
import { copyShareMixin } from '@/mixins/copy-share'
import ClickOutside from 'vue-click-outside'
import { execMetrikaMethod } from '@/utils/metrika'

export default {
  name: 'PartnerForm',

  data () {
    return {
      agree: true,
      errorMessages: null,
      form: {
        email: null,
        name: null,
        phone_number: null
      },
      submitting: false,
      successMessage: null
    }
  },

  directives: { ClickOutside },

  methods: {
    submit () {
      if (this.submitting) {
        return false
      }

      this.errorMessages = null
      this.$v.$touch()
      if (this.$v.$invalid) {
        return false
      }

      execMetrikaMethod('reachGoal', ['form3-send'])
      this.submitting = true
      const vm = this
      const data = {}
      const refCode = getReferralCode()
      if (refCode) {
        data.referral_code = refCode
      }
      this.$axios.post(API.forms.partnership(), Object.assign(data, this.form, { url: this.$route.fullPath }))
        .then(response => {
          this.successMessage = response.data.detail
          Object.keys(vm.form).forEach(k => {
            if (Object.prototype.hasOwnProperty.call(vm.form, k)) {
              vm.form[k] = null
            }
          })
          vm.$v.form.$reset()
          execMetrikaMethod('reachGoal', ['form3-success'])
          vm.$emit('submitted', response)
        })
        .catch(error => vm.parseFormErrors(error))
        .then(() => { vm.submitting = false })
    }
  },

  mixins: [copyShareMixin, formMixin, validationMixin],

  props: {
    bg: {
      type: [String, null],
      default: null,
      required: false
    },
    bgDouble: {
      type: [String, null],
      default: null,
      required: false
    },
    copyButton: {
      type: [String, null],
      default: null,
      required: false
    },
    emailTitle: {
      type: [String, null],
      default: null,
      required: false
    },
    shareButton: {
      type: [String, null],
      default: null,
      required: false
    },
    subtitle: {
      type: [String, null],
      default: null,
      required: false
    },
    successContent: {
      type: [String, null],
      default: null,
      required: false
    },
    successTitle: {
      type: [String, null],
      default: null,
      required: false
    },
    title: {
      type: [String, null],
      default: null,
      required: false
    }
  },

  validations: {
    form: {
      email: {
        email,
        required,
        fromServer (value) {
          if (value === null) return true
          return !(this.errorMessages && this.errorMessages.email)
        }
      },

      name: {
        required,
        fromServer (value) {
          if (value === '') return true
          return !(this.errorMessages && this.errorMessages.name)
        }
      },

      phone_number: {
        required,
        fromServer (value) {
          if (value === '') return true
          return !(this.errorMessages && this.errorMessages.phone_number)
        }
      }
    }
  }
}
</script>
